Option Compare Binary
Option Explicit On 
Option Strict On

Imports System
Imports System.Drawing
Imports System.IO
Imports System.Windows.Forms

''' <summary>
'''   Hauptformular des Programms.
''' </summary>
Public Class MainForm
    Inherits System.Windows.Forms.Form

    Private m_Configuration As Configuration
    Private m_PanelSelected As Boolean
    Private m_Position As Point

#Region " Windows Form Designer generated code "
    Public Sub New()
        MyBase.New()
        InitializeComponent()

        ' Setzen der Standardkonfiguration.
        m_Configuration = New Configuration(New ConfigurationData(New Point(20, 20), Color.Red))
    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    Private components As System.ComponentModel.IContainer

    Friend WithEvents btnLoad As System.Windows.Forms.Button
    Friend WithEvents btnSave As System.Windows.Forms.Button
    Friend WithEvents cmdColor As System.Windows.Forms.Button
    Friend WithEvents pnlLayer As System.Windows.Forms.Panel

    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
        Me.btnLoad = New System.Windows.Forms.Button
        Me.btnSave = New System.Windows.Forms.Button
        Me.cmdColor = New System.Windows.Forms.Button
        Me.pnlLayer = New System.Windows.Forms.Panel
        Me.SuspendLayout()
        '
        'btnLoad
        '
        Me.btnLoad.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.btnLoad.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnLoad.Location = New System.Drawing.Point(16, 336)
        Me.btnLoad.Name = "btnLoad"
        Me.btnLoad.Size = New System.Drawing.Size(72, 24)
        Me.btnLoad.TabIndex = 1
        Me.btnLoad.Text = "&Laden"
        '
        'btnSave
        '
        Me.btnSave.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.btnSave.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.btnSave.Location = New System.Drawing.Point(96, 336)
        Me.btnSave.Name = "btnSave"
        Me.btnSave.Size = New System.Drawing.Size(72, 24)
        Me.btnSave.TabIndex = 2
        Me.btnSave.Text = "&Speichern"
        '
        'cmdColor
        '
        Me.cmdColor.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.cmdColor.FlatStyle = System.Windows.Forms.FlatStyle.System
        Me.cmdColor.Location = New System.Drawing.Point(176, 336)
        Me.cmdColor.Name = "cmdColor"
        Me.cmdColor.Size = New System.Drawing.Size(72, 24)
        Me.cmdColor.TabIndex = 3
        Me.cmdColor.Text = "&Farbe..."
        '
        'pnlLayer
        '
        Me.pnlLayer.BackColor = System.Drawing.Color.White
        Me.pnlLayer.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.pnlLayer.Cursor = System.Windows.Forms.Cursors.SizeAll
        Me.pnlLayer.Location = New System.Drawing.Point(16, 16)
        Me.pnlLayer.Name = "pnlLayer"
        Me.pnlLayer.Size = New System.Drawing.Size(168, 128)
        Me.pnlLayer.TabIndex = 0
        '
        'MainForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(480, 374)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnLoad, Me.btnSave, Me.cmdColor, Me.pnlLayer})
        Me.Name = "MainForm"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "XmlSerialization"
        Me.ResumeLayout(False)

   End Sub
#End Region

    Private Sub pnlLayer_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlLayer.MouseDown
        m_PanelSelected = True
        m_Position = New Point(e.X, e.Y)
    End Sub

    Private Sub pnlLayer_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlLayer.MouseUp
        m_PanelSelected = False
    End Sub

    Private Sub pnlLayer_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pnlLayer.MouseMove
        If m_PanelSelected Then
            Me.pnlLayer.Top += e.Y - m_Position.Y
            Me.pnlLayer.Left += e.X - m_Position.X
        End If
    End Sub

    Private Sub cmdColor_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdColor.Click
        Dim cdlg As New ColorDialog
        If cdlg.ShowDialog() = DialogResult.OK Then
            Me.pnlLayer.BackColor = cdlg.Color
        End If
        cdlg.Dispose()
    End Sub

    Private Sub btnLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnLoad.Click
        Try
            m_Configuration.Load(Path.combine(Application.StartupPath, "config.xml"))
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error loading Configuration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
        Me.pnlLayer.Location = m_Configuration.Configuration.RectanglePosition
        Me.pnlLayer.BackColor = Color.FromArgb(m_Configuration.Configuration.RectangleColor)
    End Sub

    Private Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
        m_Configuration.Configuration.RectangleColor = Me.pnlLayer.BackColor.ToArgb()
        m_Configuration.Configuration.RectanglePosition = Me.pnlLayer.Location
        Try
            m_Configuration.Save(Path.Combine(Application.StartupPath, "config.xml"))
        Catch ex As Exception
            MessageBox.Show("Error: " & ex.Message, "Error saving Configuration", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub
End Class